import json
import os,sys
import struct
import unicodedata
def ConvertString(string):
    string = unicodedata.normalize('NFD', string).encode('ascii', 'ignore').decode("utf-8")
    CanUse="azertyuiopqsdfghjklmwxcvbnAZERTYUIOPQSDFGHJKLMWXCVBN1234567890 _+*/"
    newStr = ""
    for i in string:
        if i in CanUse:
            newStr +=i
    return newStr

"""
dico = {}
dico["Langues"] = ["francais", "anglais"]
dico["francais"] = ["Bonjour", "Au revoir", "Merci"]
dico["anglais"] = ["Hello", "Goodbye", "Thank you"]
with open('ListeMots/liste_francais.txt', 'r') as f:
    lines = f.readlines()
    dico["francais"] += [ConvertString(line.strip()) for line in lines]
with open('ListeMots/liste_anglais.txt', 'r') as f:
    lines = f.readlines()
    dico["anglais"] += [ConvertString(line.strip()) for line in lines]

with open('dico.json', 'w') as f:
    json.dump(dico, f, indent=4)
"""

def SaveString(fp,string):
    string = ConvertString(string)
    fp.write(struct.pack('>h', len(string)))
    fp.write(b''.join(struct.pack('>B', n) for n in str.encode(string)))

#load the json file
with open('dico.json') as json_data:
    dico = json.load(json_data)

#convert the dictionary to a binary file
with open('dico.bin', 'wb') as f:
    #write the number of languages
    f.write(struct.pack('>h', len(dico["Langues"])))
    #write the languages
    for lang in dico["Langues"]:
        SaveString(f,lang)
    #write all words in all languages ordered by language
    NbWords = len(dico[dico["Langues"][0]])
    #check if all languages have the same number of words
    for lang in dico["Langues"]:
        if len(dico[lang]) != NbWords:
            print("Error: not the same number of words in all languages")
            sys.exit()
    f.write(struct.pack('>h', NbWords))
    for i in range(NbWords):
        for lang in dico["Langues"]:
            selected_lang = dico[lang]
            SaveString(f,selected_lang[i])
